diff --git a/usr.bin/wtmpcvt/wtmpcvt.c b/usr.bin/wtmpcvt/wtmpcvt.c
new file mode 100644
index 0000000000..84d52a3042
--- /dev/null
+++ b/usr.bin/wtmpcvt/wtmpcvt.c
@@ -0,0 +1,139 @@
+/*-
+ * Copyright (c) 2010 Ed Schouten <ed@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/endian.h>
+#include <sys/param.h>
+
+#include <err.h>
+#include <stdio.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+#include <utmpx.h>
+
+struct outmp {
+	char	ut_line[8];
+	char	ut_user[16];
+	char	ut_host[16];
+        time_t  ut_time;
+};
+
+static const char vers[] = "utmpx-2.00";
+
+static void
+usage(void)
+{
+
+	fprintf(stderr, "usage: wtmpcvt input output\n");
+	exit(1);
+}
+
+static void
+outmp_to_utmpx(const struct outmp *ui, struct utmpx *uo)
+{
+
+	memset(uo, 0, sizeof *uo);
+#define	COPY_STRING(field) do {						\
+	strncpy(uo->ut_ ## field, ui->ut_ ## field,			\
+	    MIN(sizeof uo->ut_ ## field, sizeof ui->ut_ ## field));	\
+} while (0)
+#define	COPY_LINE_TO_ID() do {						\
+	strncpy(uo->ut_id, ui->ut_line,					\
+	    MIN(sizeof uo->ut_id, sizeof ui->ut_line));			\
+} while (0)
+#define	MATCH(field, value)	(strncmp(ui->ut_ ## field, (value),	\
+					sizeof(ui->ut_ ## field)) == 0)
+	if (MATCH(user, "reboot") && MATCH(line, "~")) {
+		uo->ut_type = INIT_PROCESS;
+		COPY_STRING(user);
+		COPY_STRING(line);
+	} else if (MATCH(user, "date") && MATCH(line, "|")) {
+		uo->ut_type = OLD_TIME;
+	} else if (MATCH(user, "date") && MATCH(line, "{")) {
+		uo->ut_type = NEW_TIME;
+	} else if (MATCH(user, "shutdown") && MATCH(line, "~")) {
+		uo->ut_type = INIT_PROCESS;
+		COPY_STRING(user);
+		COPY_STRING(line);
+	} else if (MATCH(user, "") && MATCH(host, "") && !MATCH(line, "")) {
+		uo->ut_type = DEAD_PROCESS;
+		COPY_LINE_TO_ID();
+	} else if (!MATCH(user, "") && !MATCH(line, "") && ui->ut_time != 0) {
+		uo->ut_type = USER_PROCESS;
+		COPY_STRING(user);
+		COPY_STRING(line);
+		COPY_STRING(host);
+		COPY_LINE_TO_ID();
+	} else {
+		uo->ut_type = EMPTY;
+		return;
+	}
+#undef COPY_STRING
+#undef COPY_LINE_TO_ID
+#undef MATCH
+
+	uo->ut_tv.tv_sec = ui->ut_time;
+	uo->ut_tv.tv_usec = 0;
+}
+
+int
+main(int argc, char *argv[])
+{
+	FILE *in, *out;
+	struct outmp ui;
+	struct utmpx uo;
+
+	if (argc != 3)
+		usage();
+
+	/* Open files. */
+	in = fopen(argv[1], "r");
+	if (in == NULL)
+		err(1, "%s", argv[1]);
+	out = fopen(argv[2], "w");
+	if (out == NULL)
+		err(1, "%s", argv[2]);
+
+	/* Write signature. */
+	memset(&uo, 0, sizeof uo);
+	uo.ut_type = SIGNATURE;
+	memcpy(uo.ut_user, vers, sizeof(vers));
+	fwrite(&uo, sizeof uo, 1, out);
+
+	/* Process entries. */
+	while (fread(&ui, sizeof ui, 1, in) == 1) {
+		outmp_to_utmpx(&ui, &uo);
+		if (uo.ut_type == EMPTY)
+			continue;
+
+		/* Write new entry to output file. */
+		fwrite(&uo, sizeof uo, 1, out);
+	}
+
+	fclose(in);
+	fclose(out);
+	return (0);
+}
diff --git a/usr.sbin/ac/Makefile b/usr.sbin/ac/Makefile
index 6a33def526..28f9a71eeb 100644
--- a/usr.sbin/ac/Makefile
+++ b/usr.sbin/ac/Makefile
@@ -1,4 +1,4 @@
-# $FreeBSD: src/usr.sbin/ac/Makefile,v 1.4.2.1 2001/04/25 12:09:11 ru Exp $
+# $FreeBSD: head/usr.sbin/ac/Makefile 239910 2012-08-30 16:45:27Z ed $
 
 PROG=	ac
 MAN=	ac.8
diff --git a/usr.sbin/ac/ac.c b/usr.sbin/ac/ac.c
index b61bff2cd1..6add63bd3c 100644
--- a/usr.sbin/ac/ac.c
+++ b/usr.sbin/ac/ac.c
@@ -1,74 +1,93 @@
-/*
- *      Copyright (c) 1994 Christopher G. Demetriou.
- *      @(#)Copyright (c) 1994, Simon J. Gerraty.
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+ *
+ * Copyright (c) 1994 Christopher G. Demetriou
+ * Copyright (c) 1994 Simon J. Gerraty
+ * Copyright (c) 2012 Ed Schouten <ed@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
  *
- *      This is free software.  It comes with NO WARRANTY.
- *      Permission to use, modify and distribute this source code
- *      is granted subject to the following conditions.
- *      1/ that the above copyright notice and this notice
- *      are preserved in all copies and that due credit be given
- *      to the author.
- *      2/ that any changes to this code are clearly commented
- *      as such so that the author does not get blamed for bugs
- *      other than his own.
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
  *
- * $FreeBSD: src/usr.sbin/ac/ac.c,v 1.14.2.2 2002/03/12 19:55:04 phantom Exp $
+ * $FreeBSD: head/usr.sbin/ac/ac.c 326276 2017-11-27 15:37:16Z pfg $
  */
 
-#include <sys/types.h>
-#include <sys/file.h>
+#include <sys/queue.h>
 #include <sys/time.h>
+
 #include <err.h>
 #include <errno.h>
 #include <langinfo.h>
 #include <locale.h>
-#include <pwd.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <timeconv.h>
 #include <unistd.h>
-#include <utmp.h>
+#include <utmpx.h>
 
 /*
  * this is for our list of currently logged in sessions
  */
-struct utmp_list {
-	struct utmp_list *next;
-	struct utmp usr;
+struct utmpx_entry {
+	SLIST_ENTRY(utmpx_entry) next;
+	char		user[sizeof(((struct utmpx *)0)->ut_user)];
+	char		id[sizeof(((struct utmpx *)0)->ut_id)];
+#ifdef CONSOLE_TTY
+	char		line[sizeof(((struct utmpx *)0)->ut_line)];
+#endif
+	struct timeval	time;
 };
 
 /*
  * this is for our list of users that are accumulating time.
  */
-struct user_list {
-	struct user_list *next;
-	char	name[UT_NAMESIZE+1];
-	time_t	secs;
+struct user_entry {
+	SLIST_ENTRY(user_entry) next;
+	char		user[sizeof(((struct utmpx *)0)->ut_user)];
+	struct timeval	time;
 };
 
 /*
  * this is for chosing whether to ignore a login
  */
-struct tty_list {
-	struct tty_list *next;
-	char	name[UT_LINESIZE+3];
-	int	len;
-	int	ret;
+struct tty_entry {
+	SLIST_ENTRY(tty_entry) next;
+	char		line[sizeof(((struct utmpx *)0)->ut_line) + 2];
+	size_t		len;
+	int		ret;
 };
 
 /*
  * globals - yes yuk
  */
 #ifdef CONSOLE_TTY
-static char 	*Console = CONSOLE_TTY;
+static const char *Console = CONSOLE_TTY;
 #endif
-static time_t	Total = 0;
-static time_t	FirstTime = 0;
+static struct timeval Total = { 0, 0 };
+static struct timeval FirstTime = { 0, 0 };
 static int	Flags = 0;
-static struct user_list *Users = NULL;
-static struct tty_list *Ttys = NULL;
-
-#define NEW(type) (type *)malloc(sizeof(type))
+static SLIST_HEAD(, utmpx_entry) CurUtmpx = SLIST_HEAD_INITIALIZER(CurUtmpx);
+static SLIST_HEAD(, user_entry) Users = SLIST_HEAD_INITIALIZER(Users);
+static SLIST_HEAD(, tty_entry) Ttys = SLIST_HEAD_INITIALIZER(Ttys);
 
 #define	AC_W	1				/* not _PATH_WTMP */
 #define	AC_D	2				/* daily totals (ignore -p) */
@@ -76,90 +95,56 @@ static struct tty_list *Ttys = NULL;
 #define	AC_U	8				/* specified users only */
 #define	AC_T	16				/* specified ttys only */
 
-#ifdef DEBUG
-static int Debug = 0;
-#endif
-
-static int		ac(FILE *);
-static struct tty_list	*add_tty(char *);
-static int		do_tty(char *);
-static FILE		*file(const char *);
-static struct utmp_list	*log_in(struct utmp_list *, struct utmp *);
-static struct utmp_list	*log_out(struct utmp_list *, struct utmp *);
-#ifdef CONSOLE_TTY
-static int		on_console(struct utmp_list *);
-#endif
-static void		show(const char *, time_t);
-static void		show_today(struct user_list *, struct utmp_list *,
-			    time_t);
-static void		show_users(struct user_list *);
-static struct user_list	*update_user(struct user_list *, char *, time_t);
-static void		usage(void) __dead2;
+static void	ac(const char *);
+static void	usage(void) __dead2;
 
-/*
- * open wtmp or die
- */
-static FILE *
-file(const char *name)
-{
-	FILE *fp;
-
-	if ((fp = fopen(name, "r")) == NULL)
-		err(1, "%s", name);
-	/* in case we want to discriminate */
-	if (strcmp(_PATH_WTMP, name))
-		Flags |= AC_W;
-	return fp;
-}
-
-static struct tty_list *
-add_tty(char *name)
+static void
+add_tty(const char *line)
 {
-	struct tty_list *tp;
+	struct tty_entry *tp;
 	char *rcp;
 
 	Flags |= AC_T;
 
-	if ((tp = NEW(struct tty_list)) == NULL)
+	if ((tp = malloc(sizeof(*tp))) == NULL)
 		errx(1, "malloc failed");
 	tp->len = 0;				/* full match */
 	tp->ret = 1;				/* do if match */
-	if (*name == '!') {			/* don't do if match */
+	if (*line == '!') {			/* don't do if match */
 		tp->ret = 0;
-		name++;
+		line++;
 	}
-	strncpy(tp->name, name, sizeof(tp->name) - 1);
-	tp->name[sizeof(tp->name) - 1] = '\0';
-	if ((rcp = strchr(tp->name, '*')) != NULL) {	/* wild card */
+	strlcpy(tp->line, line, sizeof(tp->line));
+	/* Wildcard. */
+	if ((rcp = strchr(tp->line, '*')) != NULL) {
 		*rcp = '\0';
-		tp->len = strlen(tp->name);	/* match len bytes only */
+		/* Match len bytes only. */
+		tp->len = strlen(tp->line);
 	}
-	tp->next = Ttys;
-	Ttys = tp;
-	return Ttys;
+	SLIST_INSERT_HEAD(&Ttys, tp, next);
 }
 
 /*
  * should we process the named tty?
  */
 static int
-do_tty(char *name)
+do_tty(const char *line)
 {
-	struct tty_list *tp;
+	struct tty_entry *tp;
 	int def_ret = 0;
 
-	for (tp = Ttys; tp != NULL; tp = tp->next) {
+	SLIST_FOREACH(tp, &Ttys, next) {
 		if (tp->ret == 0)		/* specific don't */
 			def_ret = 1;		/* default do */
 		if (tp->len != 0) {
-			if (strncmp(name, tp->name, tp->len) == 0)
+			if (strncmp(line, tp->line, tp->len) == 0)
 				return tp->ret;
 		} else {
-			if (strncmp(name, tp->name, sizeof(tp->name)) == 0)
+			if (strncmp(line, tp->line, sizeof(tp->line)) == 0)
 				return tp->ret;
 		}
 	}
-	return def_ret;
+	return (def_ret);
 }
 
 #ifdef CONSOLE_TTY
@@ -167,66 +152,66 @@ do_tty(char *name)
  * is someone logged in on Console?
  */
 static int
-on_console(struct utmp_list *head)
+on_console(void)
 {
-	struct utmp_list *up;
+	struct utmpx_entry *up;
 
-	for (up = head; up; up = up->next) {
-		if (strncmp(up->usr.ut_line, Console,
-		    sizeof(up->usr.ut_line)) == 0)
-			return 1;
-	}
-	return 0;
+	SLIST_FOREACH(up, &CurUtmpx, next)
+		if (strcmp(up->line, Console) == 0)
+			return (1);
+	return (0);
 }
 #endif
 
 /*
- * update user's login time
+ * Update user's login time.
+ * If no entry for this user is found, a new entry is inserted into the
+ * list alphabetically.
  */
-static struct user_list *
-update_user(struct user_list *head, char *name, time_t secs)
+static void
+update_user(const char *user, struct timeval secs)
 {
-	struct user_list *up;
+	struct user_entry *up, *aup;
+	int c;
 
-	for (up = head; up != NULL; up = up->next) {
-		if (strncmp(up->name, name, UT_NAMESIZE) == 0) {
-			up->secs += secs;
-			Total += secs;
-			return head;
-		}
+	aup = NULL;
+	SLIST_FOREACH(up, &Users, next) {
+		c = strcmp(up->user, user);
+		if (c == 0) {
+			timeradd(&up->time, &secs, &up->time);
+			timeradd(&Total, &secs, &Total);
+			return;
+		} else if (c > 0)
+			break;
+		aup = up;
 	}
 	/*
 	 * not found so add new user unless specified users only
 	 */
 	if (Flags & AC_U)
-		return head;
+		return;
 
-	if ((up = NEW(struct user_list)) == NULL)
+	if ((up = malloc(sizeof(*up))) == NULL)
 		errx(1, "malloc failed");
-	up->next = head;
-	strncpy(up->name, name, sizeof(up->name) - 1);
-	up->name[sizeof(up->name) - 1] = '\0';	/* paranoid! */
-	up->secs = secs;
-	Total += secs;
-	return up;
+	if (aup == NULL)
+		SLIST_INSERT_HEAD(&Users, up, next);
+	else
+		SLIST_INSERT_AFTER(aup, up, next);
+	strlcpy(up->user, user, sizeof(up->user));
+	up->time = secs;
+	timeradd(&Total, &secs, &Total);
 }
 
 int
-main(int argc, char **argv)
+main(int argc, char *argv[])
 {
-	FILE *fp;
+	const char *wtmpf = NULL;
 	int c;
 
 	setlocale(LC_TIME, "");
 
-	fp = NULL;
-	while ((c = getopt(argc, argv, "Dc:dpt:w:")) != -1) {
+	while ((c = getopt(argc, argv, "c:dpt:w:")) != -1) {
 		switch (c) {
-#ifdef DEBUG
-		case 'D':
-			Debug++;
-			break;
-#endif
 		case 'c':
 #ifdef CONSOLE_TTY
 			Console = optarg;
@@ -244,7 +229,8 @@ main(int argc, char **argv)
 			add_tty(optarg);
 			break;
 		case 'w':
-			fp = file(optarg);
+			Flags |= AC_W;
+			wtmpf = optarg;
 			break;
 		case '?':
 		default:
@@ -257,129 +243,111 @@ main(int argc, char **argv)
 		 * initialize user list
 		 */
 		for (; optind < argc; optind++) {
-			Users = update_user(Users, argv[optind], 0L);
+			update_user(argv[optind], (struct timeval){ 0, 0 });
 		}
 		Flags |= AC_U;			/* freeze user list */
 	}
 	if (Flags & AC_D)
 		Flags &= ~AC_P;
-	if (fp == NULL) {
-		/*
-		 * if _PATH_WTMP does not exist, exit quietly
-		 */
-		if (access(_PATH_WTMP, 0) != 0 && errno == ENOENT)
-			return 0;
+	ac(wtmpf);
 
-		fp = file(_PATH_WTMP);
-	}
-	ac(fp);
-
-	return 0;
+	return (0);
 }
 
 /*
  * print login time in decimal hours
  */
 static void
-show(const char *name, time_t secs)
+show(const char *user, struct timeval secs)
 {
-	printf("\t%-*s %8.2f\n", UT_NAMESIZE, name,
-	    ((double)secs / 3600));
+	printf("\t%-*s %8.2f\n",
+	    (int)sizeof(((struct user_entry *)0)->user), user,
+	    (double)secs.tv_sec / 3600);
 }
 
 static void
-show_users(struct user_list *list)
+show_users(void)
 {
-	struct user_list *lp;
+	struct user_entry *lp;
 
-	for (lp = list; lp; lp = lp->next)
-		show(lp->name, lp->secs);
+	SLIST_FOREACH(lp, &Users, next)
+		show(lp->user, lp->time);
 }
 
 /*
  * print total login time for 24hr period in decimal hours
  */
 static void
-show_today(struct user_list *users, struct utmp_list *logins, time_t secs)
+show_today(struct timeval today)
 {
-	struct user_list *up;
-	struct utmp_list *lp;
+	struct user_entry *up;
+	struct utmpx_entry *lp;
 	char date[64];
-	time_t yesterday = secs - 1;
+	struct timeval diff, total = { 0, 0 }, usec = { 0, 1 }, yesterday;
 	static int d_first = -1;
 
 	if (d_first < 0)
 		d_first = (*nl_langinfo(D_MD_ORDER) == 'd');
+	timersub(&today, &usec, &yesterday);
 	strftime(date, sizeof(date),
 		       d_first ? "%e %b  total" : "%b %e  total",
-		       localtime(&yesterday));
-
-	/* restore the missing second */
-	yesterday++;
+		       localtime(&yesterday.tv_sec));
 
-	for (lp = logins; lp != NULL; lp = lp->next) {
-		secs = yesterday - lp->usr.ut_time;
-		Users = update_user(Users, lp->usr.ut_name, secs);
-		lp->usr.ut_time = yesterday;	/* as if they just logged in */
+	SLIST_FOREACH(lp, &CurUtmpx, next) {
+		timersub(&today, &lp->time, &diff);
+		update_user(lp->user, diff);
+		/* As if they just logged in. */
+		lp->time = today;
 	}
-	secs = 0;
-	for (up = users; up != NULL; up = up->next) {
-		secs += up->secs;
-		up->secs = 0;			/* for next day */
+	SLIST_FOREACH(up, &Users, next) {
+		timeradd(&total, &up->time, &total);
+		/* For next day. */
+		timerclear(&up->time);
 	}
- 	if (secs)
-		printf("%s %11.2f\n", date, ((double)secs / 3600));
+	if (timerisset(&total))
+		printf("%s %11.2f\n", date, (double)total.tv_sec / 3600);
 }
 
 /*
- * log a user out and update their times.
- * if ut_line is "~", we log all users out as the system has
- * been shut down.
+ * Log a user out and update their times.
+ * If ut_type is BOOT_TIME or INIT_PROCESS, we log all users out as the
+ * system has been shut down.
  */
-static struct utmp_list *
-log_out(struct utmp_list *head, struct utmp *up)
+static void
+log_out(const struct utmpx *up)
 {
-	struct utmp_list *lp, *lp2, *tlp;
-	time_t secs;
-
-	for (lp = head, lp2 = NULL; lp != NULL; )
-		if (*up->ut_line == '~' || strncmp(lp->usr.ut_line, up->ut_line,
-		    sizeof(up->ut_line)) == 0) {
-			secs = up->ut_time - lp->usr.ut_time;
-			Users = update_user(Users, lp->usr.ut_name, secs);
-#ifdef DEBUG
-			if (Debug)
-				printf("%-.*s %-.*s: %-.*s logged out (%2d:%02d:%02d)\n",
-				    19, ctime(&up->ut_time),
-				    sizeof(lp->usr.ut_line), lp->usr.ut_line,
-				    sizeof(lp->usr.ut_name), lp->usr.ut_name,
-				    secs / 3600, (secs % 3600) / 60, secs % 60);
-#endif
+	struct utmpx_entry *lp, *lp2, *tlp;
+	struct timeval secs;
+
+	for (lp = SLIST_FIRST(&CurUtmpx), lp2 = NULL; lp != NULL;)
+		if (up->ut_type == BOOT_TIME || up->ut_type == INIT_PROCESS ||
+		    (up->ut_type == DEAD_PROCESS &&
+		    memcmp(lp->id, up->ut_id, sizeof(up->ut_id)) == 0)) {
+			timersub(&up->ut_tv, &lp->time, &secs);
+			update_user(lp->user, secs);
 			/*
 			 * now lose it
 			 */
 			tlp = lp;
-			lp = lp->next;
-			if (tlp == head)
-				head = lp;
-			else if (lp2 != NULL)
-				lp2->next = lp;
+			lp = SLIST_NEXT(lp, next);
+			if (lp2 == NULL)
+				SLIST_REMOVE_HEAD(&CurUtmpx, next);
+			else
+				SLIST_REMOVE_AFTER(lp2, next);
 			free(tlp);
 		} else {
 			lp2 = lp;
-			lp = lp->next;
+			lp = SLIST_NEXT(lp, next);
 		}
-	return head;
 }
 
-
 /*
  * if do_tty says ok, login a user
  */
-static struct utmp_list *
-log_in(struct utmp_list *head, struct utmp *up)
+static void
+log_in(struct utmpx *up)
 {
-	struct utmp_list *lp;
+	struct utmpx_entry *lp;
 
 	/*
 	 * this could be a login. if we're not dealing with
@@ -398,140 +366,147 @@ log_in(struct utmp_list *head, struct utmp *up)
 		 * SunOS 4.0.2 does not treat ":0.0" as special but we
 		 * do.
 		 */
-		if (on_console(head))
-			return head;
+		if (on_console())
+			return;
 		/*
 		 * ok, no recorded login, so they were here when wtmp
 		 * started!  Adjust ut_time!
 		 */
-		up->ut_time = FirstTime;
+		up->ut_tv = FirstTime;
 		/*
 		 * this allows us to pick the right logout
 		 */
-		strncpy(up->ut_line, Console, sizeof(up->ut_line) - 1);
-		up->ut_line[sizeof(up->ut_line) - 1] = '\0'; /* paranoid! */
+		strlcpy(up->ut_line, Console, sizeof(up->ut_line));
 	}
 #endif
 	/*
 	 * If we are doing specified ttys only, we ignore
 	 * anything else.
 	 */
-	if (Flags & AC_T)
-		if (!do_tty(up->ut_line))
-			return head;
+	if (Flags & AC_T && !do_tty(up->ut_line))
+		return;
 
 	/*
 	 * go ahead and log them in
 	 */
-	if ((lp = NEW(struct utmp_list)) == NULL)
+	if ((lp = malloc(sizeof(*lp))) == NULL)
 		errx(1, "malloc failed");
-	lp->next = head;
-	head = lp;
-	memmove((char *)&lp->usr, (char *)up, sizeof(struct utmp));
-#ifdef DEBUG
-	if (Debug) {
-		printf("%-.*s %-.*s: %-.*s logged in", 19,
-		    ctime(&lp->usr.ut_time), sizeof(up->ut_line),
-		       up->ut_line, sizeof(up->ut_name), up->ut_name);
-		if (*up->ut_host)
-			printf(" (%-.*s)", sizeof(up->ut_host), up->ut_host);
-		putchar('\n');
-	}
+	SLIST_INSERT_HEAD(&CurUtmpx, lp, next);
+	strlcpy(lp->user, up->ut_user, sizeof(lp->user));
+	memcpy(lp->id, up->ut_id, sizeof(lp->id));
+#ifdef CONSOLE_TTY
+	memcpy(lp->line, up->ut_line, sizeof(lp->line));
 #endif
-	return head;
+	lp->time = up->ut_tv;
 }
 
-static int
-ac(FILE *fp)
+static void
+ac(const char *file)
 {
-	struct utmp_list *lp, *head = NULL;
-	struct utmp usr;
+	struct utmpx_entry *lp;
+	struct utmpx *usr, usht;
 	struct tm *ltm;
-	time_t secs;
-	int day = -1;
-
-	secs = 0;
-
-	while (fread((char *)&usr, sizeof(usr), 1, fp) == 1) {
-		if (!FirstTime)
-			FirstTime = usr.ut_time;
+	struct timeval prev_secs, ut_timecopy, secs, clock_shift, now;
+	int day, rfound;
+
+	day = -1;
+	timerclear(&prev_secs);	/* Minimum acceptable date == 1970. */
+	timerclear(&secs);
+	timerclear(&clock_shift);
+	rfound = 0;
+	if (setutxdb(UTX_DB_WTMPX, file) != 0)
+		err(1, "%s", file);
+	while ((usr = getutxent()) != NULL) {
+		rfound++;
+		ut_timecopy = usr->ut_tv;
+		/* Don't let the time run backwards. */
+		if (timercmp(&ut_timecopy, &prev_secs, <))
+			ut_timecopy = prev_secs;
+		prev_secs = ut_timecopy;
+
+		if (!timerisset(&FirstTime))
+			FirstTime = ut_timecopy;
 		if (Flags & AC_D) {
-			ltm = localtime(&usr.ut_time);
+			ltm = localtime(&ut_timecopy.tv_sec);
 			if (day >= 0 && day != ltm->tm_yday) {
 				day = ltm->tm_yday;
 				/*
 				 * print yesterday's total
 				 */
-				secs = usr.ut_time;
-				secs -= ltm->tm_sec;
-				secs -= 60 * ltm->tm_min;
-				secs -= 3600 * ltm->tm_hour;
-				show_today(Users, head, secs);
+				secs = ut_timecopy;
+				secs.tv_sec -= ltm->tm_sec;
+				secs.tv_sec -= 60 * ltm->tm_min;
+				secs.tv_sec -= 3600 * ltm->tm_hour;
+				secs.tv_usec = 0;
+				show_today(secs);
 			} else
 				day = ltm->tm_yday;
 		}
-		switch(*usr.ut_line) {
-		case '|':
-			secs = usr.ut_time;
+		switch(usr->ut_type) {
+		case OLD_TIME:
+			clock_shift = ut_timecopy;
 			break;
-		case '{':
-			secs -= usr.ut_time;
+		case NEW_TIME:
+			timersub(&clock_shift, &ut_timecopy, &clock_shift);
 			/*
 			 * adjust time for those logged in
 			 */
-			for (lp = head; lp != NULL; lp = lp->next)
-				lp->usr.ut_time -= secs;
+			SLIST_FOREACH(lp, &CurUtmpx, next)
+				timersub(&lp->time, &clock_shift, &lp->time);
 			break;
-		case '~':			/* reboot or shutdown */
-			head = log_out(head, &usr);
-			FirstTime = usr.ut_time; /* shouldn't be needed */
+		case BOOT_TIME:
+		case INIT_PROCESS:
+			log_out(usr);
+			FirstTime = ut_timecopy; /* shouldn't be needed */
 			break;
-		default:
+		case USER_PROCESS:
 			/*
-			 * if they came in on tty[p-sP-S]*, then it is only
-			 * a login session if the ut_host field is non-empty
+			 * If they came in on pts/..., then it is only
+			 * a login session if the ut_host field is non-empty.
 			 */
-			if (*usr.ut_name) {
-				if (strncmp(usr.ut_line, "tty", 3) != 0 ||
-				    strchr("pqrsPQRS", usr.ut_line[3]) == 0 ||
-				    *usr.ut_host != '\0')
-					head = log_in(head, &usr);
-			} else
-				head = log_out(head, &usr);
+			if (strncmp(usr->ut_line, "pts/", 4) != 0 ||
+			    *usr->ut_host != '\0')
+				log_in(usr);
+			break;
+		case DEAD_PROCESS:
+			log_out(usr);
 			break;
 		}
 	}
-	fclose(fp);
-	if (!(Flags & AC_W))
-		usr.ut_time = time(NULL);
-	strcpy(usr.ut_line, "~");
+	endutxent();
+	gettimeofday(&now, NULL);
+	if (Flags & AC_W)
+		usht.ut_tv = ut_timecopy;
+	else
+		usht.ut_tv = now;
+	usht.ut_type = INIT_PROCESS;
 
 	if (Flags & AC_D) {
-		ltm = localtime(&usr.ut_time);
+		ltm = localtime(&ut_timecopy.tv_sec);
 		if (day >= 0 && day != ltm->tm_yday) {
 			/*
 			 * print yesterday's total
 			 */
-			secs = usr.ut_time;
-			secs -= ltm->tm_sec;
-			secs -= 60 * ltm->tm_min;
-			secs -= 3600 * ltm->tm_hour;
-			show_today(Users, head, secs);
+			secs = ut_timecopy;
+			secs.tv_sec -= ltm->tm_sec;
+			secs.tv_sec -= 60 * ltm->tm_min;
+			secs.tv_sec -= 3600 * ltm->tm_hour;
+			secs.tv_usec = 0;
+			show_today(secs);
 		}
 	}
 	/*
 	 * anyone still logged in gets time up to now
 	 */
-	head = log_out(head, &usr);
+	log_out(&usht);
 
 	if (Flags & AC_D)
-		show_today(Users, head, time(NULL));
+		show_today(now);
 	else {
 		if (Flags & AC_P)
-			show_users(Users);
+			show_users();
 		show("total", Total);
 	}
-	return 0;
 }
 
 static void
diff --git a/usr.sbin/lastlogin/lastlogin.c b/usr.sbin/lastlogin/lastlogin.c
index 729c59b314..9b5bd3d41b 100644
--- a/usr.sbin/lastlogin/lastlogin.c
+++ b/usr.sbin/lastlogin/lastlogin.c
@@ -40,11 +40,9 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <time.h>
-#include <utmp.h>
 #include <utmpx.h>
 #include <unistd.h>
 
-static	void	output(struct passwd *, struct lastlog *);
 static	void	outputx(struct passwd *, struct lastlogx *);
 static	void	usage(void);
 
@@ -52,19 +50,13 @@ int
 main(int argc, char **argv)
 {
 	int	ch, i;
-	long offset;
-	FILE	*fp;
 	struct passwd	*passwd;
-	struct lastlog	last;
 	struct lastlogx	lastx;
 
 	while ((ch = getopt(argc, argv, "")) != -1) {
 		usage();
 	}
 
-	if ((fp = fopen(_PATH_LASTLOG, "r")) == NULL)
-		err(1, "%s", _PATH_LASTLOG);
-
 	setpassent(1);	/* Keep passwd file pointers open */
 
 	/* Process usernames given on the command line. */
@@ -79,18 +71,6 @@ main(int argc, char **argv)
 				outputx(passwd, &lastx);
 				goto done;
 			}
-			/* Calculate the offset into the lastlog file. */
-			offset = (long)(passwd->pw_uid * sizeof(last));
-			if (fseek(fp, offset, SEEK_SET)) {
-				warn("fseek error");
-				continue;
-			}
-			if (fread(&last, sizeof(last), 1, fp) != 1) {
-				warnx("fread error on '%s'", passwd->pw_name);
-				clearerr(fp);
-				continue;
-			}
-			output(passwd, &last);
 		}
 	}
 	/* Read all lastlog entries, looking for active ones */
@@ -101,57 +81,21 @@ main(int argc, char **argv)
 				if (lastx.ll_tv.tv_sec == 0)
 					continue;
 				outputx(passwd, &lastx);
-			} else {
-				offset = (long)(passwd->pw_uid * sizeof(last));
-
-				if (fseek(fp, offset, SEEK_SET)) {
-					continue;
-				}
-				if (fread(&last, sizeof(last), 1, fp) != 1) {
-					continue;
-				}
-				if (last.ll_time == 0)
-					continue;
-				output(passwd, &last);
 			}
 		}
-#if 0
-		for (i = 0; fread(&last, sizeof(last), 1, fp) == 1; i++) {
-			if (last.ll_time == 0)
-				continue;
-			if ((passwd = getpwuid((uid_t)i)) != NULL)
-				output(passwd, &last);
-		}
-		if (ferror(fp))
-			warnx("fread error");
-#endif
 	}
 
 done:
 	setpassent(0);	/* Close passwd file pointers */
 
-	fclose(fp);
 	exit(0);
 }
 
-/* Duplicate the output of last(1) */
-static void
-output(struct passwd *p, struct lastlog *l)
-{
-	printf("%-*.*s  %-*.*s %-*.*s   %s",
-		UT_NAMESIZE, UT_NAMESIZE, p->pw_name,
-		UT_LINESIZE+4, UT_LINESIZE+4, l->ll_line,
-		UT_HOSTSIZE, UT_HOSTSIZE, l->ll_host,
-		(l->ll_time) ? ctime(&(l->ll_time)) : "Never logged in\n");
-}
-
 static void
 outputx(struct passwd *p, struct lastlogx *l)
 {
-	printf("%-*.*s  %-*.*s %-*.*s   %s",
-		UT_NAMESIZE, UT_NAMESIZE, p->pw_name,
-		UT_LINESIZE+4, UT_LINESIZE+4, l->ll_line,
-		UT_HOSTSIZE, UT_HOSTSIZE, l->ll_host,
+	printf("%-10s  %-8s %-22.22s   %s",
+		p->pw_name, l->ll_line, l->ll_host,
 		(l->ll_tv.tv_sec) ? ctime((&l->ll_tv.tv_sec)) : "Never logged in\n");
 }
 
diff --git a/usr.sbin/ppp/id.c b/usr.sbin/ppp/id.c
index 154970657d..5a077ecdb3 100644
--- a/usr.sbin/ppp/id.c
+++ b/usr.sbin/ppp/id.c
@@ -24,7 +24,6 @@
  * SUCH DAMAGE.
  *
  * $FreeBSD: src/usr.sbin/ppp/id.c,v 1.18.2.3 2002/09/01 02:12:27 brian Exp $
- * $DragonFly: src/usr.sbin/ppp/id.c,v 1.4 2005/11/24 23:42:54 swildner Exp $
  */
 
 #include <sys/param.h>
@@ -50,7 +49,7 @@
 #else
 #include <libutil.h>
 #endif
-#include <utmp.h>
+#include <utmpx.h>
 
 #include "log.h"
 #include "main.h"
@@ -203,36 +202,25 @@ ID0uu_unlock(const char *basettyname)
 }
 
 void
-ID0login(struct utmp *ut)
+ID0login(const struct utmpx *ut)
 {
   ID0set0();
-  if (logout(ut->ut_line)) {
-    log_Printf(LogID0, "logout(\"%s\")\n", ut->ut_line);
-    logwtmp(ut->ut_line, "", "");
-    log_Printf(LogID0, "logwtmp(\"%s\", \"\", \"\")\n", ut->ut_line);
-  }
-  login(ut);
-  log_Printf(LogID0, "login(\"%s\", \"%.*s\")\n",
-            ut->ut_line, (int)(sizeof ut->ut_name), ut->ut_name);
+  pututxline(ut);
+  log_Printf(LogID0, "pututxline(\"%.*s\", \"%.*s\", \"%.*s\", \"%.*s\")\n",
+      (int)sizeof ut->ut_id, ut->ut_id,
+      (int)sizeof ut->ut_user, ut->ut_user,
+      (int)sizeof ut->ut_line, ut->ut_line,
+      (int)sizeof ut->ut_host, ut->ut_host);
   ID0setuser();
 }
 
 void
-ID0logout(const char *device, int nologout)
+ID0logout(const struct utmpx *ut)
 {
-  struct utmp ut;
-  char ut_line[sizeof ut.ut_line + 1];
-
-  strncpy(ut_line, device, sizeof ut_line - 1);
-  ut_line[sizeof ut_line - 1] = '\0';
-
   ID0set0();
-  if (nologout || logout(ut_line)) {
-    log_Printf(LogID0, "logout(\"%s\")\n", ut_line);
-    logwtmp(ut_line, "", "");
-    log_Printf(LogID0, "logwtmp(\"%s\", \"\", \"\")\n", ut_line);
-  } else
-    log_Printf(LogERROR, "ID0logout: No longer logged in on %s\n", ut_line);
+  pututxline(ut);
+  log_Printf(LogID0, "pututxline(\"%.*s\")\n",
+      (int)sizeof ut->ut_id, ut->ut_id);
   ID0setuser();
 }
 
diff --git a/usr.sbin/ppp/id.h b/usr.sbin/ppp/id.h
index 9223c118b7..615e588416 100644
--- a/usr.sbin/ppp/id.h
+++ b/usr.sbin/ppp/id.h
@@ -24,11 +24,10 @@
  * SUCH DAMAGE.
  *
  * $FreeBSD: src/usr.sbin/ppp/id.h,v 1.13.2.1 2000/08/19 09:30:03 brian Exp $
- * $DragonFly: src/usr.sbin/ppp/id.h,v 1.3 2004/02/03 07:11:47 dillon Exp $
  */
 
 #ifndef NOSUID
-struct utmp;
+struct utmpx;
 struct sockaddr_un;
 
 extern void ID0init(void);
@@ -42,8 +41,8 @@ extern int ID0write(int, const void *, size_t);
 extern int ID0uu_lock(const char *);
 extern int ID0uu_lock_txfr(const char *, pid_t);
 extern int ID0uu_unlock(const char *);
-extern void ID0login(struct utmp *);
-extern void ID0logout(const char *, int);
+extern void ID0login(const struct utmpx *);
+extern void ID0logout(const struct utmpx *);
 extern int ID0bind_un(int, const struct sockaddr_un *);
 extern int ID0connect_un(int, const struct sockaddr_un *);
 extern int ID0kill(pid_t, int);
@@ -65,20 +64,8 @@ extern int ID0NgMkSockNode(const char *, int *, int *);
 #define ID0uu_lock uu_lock
 #define ID0uu_lock_txfr uu_lock_txfr
 #define ID0uu_unlock uu_unlock
-#define ID0login(u)			\
-  do {					\
-    if (logout((u)->ut_line))		\
-      logwtmp((u)->ut_line, "", "");	\
-    login(u);				\
-  } while (0)
-#define ID0logout(dev, no)				\
-  do {							\
-    struct utmp ut;					\
-    strncpy(ut.ut_line, dev, sizeof ut.ut_line - 1);	\
-    ut.ut_line[sizeof ut.ut_line - 1] = '\0';		\
-    if (no || logout(ut.ut_line))			\
-      logwtmp(ut.ut_line, "", ""); 			\
-  } while (0)
+#define ID0login pututxline
+#define ID0logout pututxline
 #define ID0bind_un(s, n) bind(s, (const struct sockaddr *)(n), sizeof *(n))
 #define ID0connect_un(s, n) \
 	connect(s, (const struct sockaddr *)(n), sizeof *(n))
